//=================================================================================================
RT_HW_PIN_DIR_ID  idCnt, idTst1, idTst2, idTst3;
RT_HW_PIN_DIN_ID  idBut, idBlock, idBlink;
RT_HW_PIN_ADC_ID  idADC;
RT_HW_PIN_DOT_ID  idLed;
RT_HW_PIN_TCH_ID  idTCH;
RT_HW_PIN_HALL_ID idHALL;
RT_HW_PIN_PWM_ID  idPWM;
RT_HW_PIN_DAC_ID  idDAC;
//=================================================================================================
RT_HW_LCD_HD44780_PARAM_CHAR_ID idLcdBlink11, idLcdBlink21, idLcdBlink31, idLcdBlink41; //--Для вывода blink;
RT_HW_LCD_HD44780_PARAM_CHAR_ID idLcdBlink12, idLcdBlink22, idLcdBlink32, idLcdBlink42; //--Для вывода blink;
RT_HW_LCD_HD44780_PARAM_CHAR_ID idLcdBit11,   idLcdBit21,   idLcdBit31,   idLcdBit41;   //--Для вывода bool;
RT_HW_LCD_HD44780_PARAM_CHAR_ID idLcdChar11,  idLcdChar21,  idLcdChar31,  idLcdChar41;  //--Для вывода char;
//------------------------------------------------------------------------------------------------
RT_HW_LCD_HD44780_PARAM_VAL_ID  idLcdIADC11,  idLcdIADC21;                             //--Для вывода int  -ADC;
RT_HW_LCD_HD44780_PARAM_VAL_ID  idLcdFADC11,  idLcdFADC21;                             //--Для вывода float-ADC;
RT_HW_LCD_HD44780_PARAM_VAL_ID  idLcdPWM11,   idLcdPWM21,  idLcdPWM31,  idLcdPWM41;    //--Для вывода HEX  -PWM;
//------------------------------------------------------------------------------------------------
RT_HW_LCD_HD44780_PARAM_TEXT_ID idLcdPGM11,  idLcdPGM21,  idLcdPGM31,  idLcdPGM41;    //--Вывод текста из PROGMEM;
RT_HW_LCD_HD44780_PARAM_TEXT_ID idLcdSTR11,  idLcdSTR21,  idLcdSTR31,  idLcdSTR41;    //--Вывод текста из PROGMEM;
//=================================================================================================
bool        runConsoleHead;                                                           //--Флаг запуска задачи "Вывод заголовков";
uint8_t     initParam{0};                                                             //--Параметр для инициализации параметров;
uint8_t     numQuick, numFast, numSlow, numBack, numFrdm;                             //--Номера задач для диспетчера задач;
uint8_t     num_1{15}, num_2{15}, num_3{15}, num_4{15}, num_5{15}, num_6{15};         //--Номера Lcd;
//------------------------------------------------------------------------------------------------
String      vStr;                                                                     //--Переменная для вывода строчной переменной;
char        vChar;                                                                    //--Переменная для вывода символа;
uint8_t     cntChar{0}, cntStr{0}, cntDivStr{0}, cntNsec{0}, cntNumTextPGM{0};        //--Счетчики;
int32_t     buffFADC11;                                                               //--Буфер для вывода float vFADC через int32_t;
uint8_t     cntAgoPGM11, cntAgoPGM21, cntAgoPGM31, cntAgoPGM41;                       //--Буферы для счетчиков;
uint16_t    crcAgoSTR11, crcAgoSTR21, crcAgoSTR31, crcAgoSTR41;                       //--Буферы для CRC16;
//------------------------------------------------------------------------------------------------
bool    vnCnt, vnTst1, vnTst2, vdTst3;                    //--Cnt,Tst1,Tst2,Tst3  -значения нормал. и на устройстве;
bool    vnBut, vdBut, vnLed, vdLed;                       //But,Led - значения нормализованное и на устройстве;
bool    vnBlock, vnBlink, vdBlock, vdBlink;               //--Block,Blink-значения с кнопок управления Lcd;
int16_t vnADC, vdADC, vnMinusADC, vnPWM, vdPWM;;          //--ADC,PWM - значения нормализованное и на устройстве;
int16_t vnAgoADC11, vdAgoADC11, vnMinusAgoADC11;          //--ADC - значения нормализованное и на устройстве;
int16_t vnAgoADC21, vdAgoADC21, vnMinusAgoADC21;          //--ADC - значения нормализованное и на устройстве;
int16_t vnTCH, vdTCH, vnHALL, vdHALL;                     //--TCH,HALL- значения нормализованное и на устройстве;
int16_t vdAgoPWM11, vdAgoPWM21, vdAgoPWM31, vdAgoPWM41;   //--AgoPWM;
int16_t vnDAC, vdDAC;                                     //--DAC - значения нормализованное и  c устройства;
float   vFADC;                                            //--ADC - значение с ADC в вольтах;
//------------------------------------------------------------------------------------------------
const char  PGM_ADC[] PROGMEM = "АЦП=";
const char  PGM_aE[]  PROGMEM = "a=";
const char  PGM_vE[]  PROGMEM = "v=";
const char  PGM_hE[]  PROGMEM = "h=";
const char  PGM_HE[]  PROGMEM = "H=";
const char  text0[]   PROGMEM = "FLProg";
const char  text1[]   PROGMEM = "Arduino";
const char  text2[]   PROGMEM = "Академия";
const char  text3[]   PROGMEM = "Проверка";
const char  text4[]   PROGMEM = "Тест";
const char  text5[]   PROGMEM = "EIS";
const char  text6[]   PROGMEM = "Успех";
const char* textN11 = text0;                            //--Буфер адреса выводимого текста из PROGMEM;
const char* textN21 = text0;                            //--Буфер адреса выводимого текста из PROGMEM;
const char* textN31 = text0;                            //--Буфер адреса выводимого текста из PROGMEM;
const char* textN41 = text0;                            //--Буфер адреса выводимого текста из PROGMEM;
//-------------------------------------------------------------------------------------------------

//=================================================================================================
//------------------------------------------------------------------------------------------------
//  Функция "Формирование переменной адреса текста из PROGMEM по номеру"
//------------------------------------------------------------------------------------------------
const char* getNameStrPGM(uint8_t num = 0) {            //--Функция выбора текста из PROGMEM по номеру;
  if (num == 0) {return text0;}
  if (num == 1) {return text1;}
  if (num == 2) {return text2;}
  if (num == 3) {return text3;}
  if (num == 4) {return text4;}
  if (num == 5) {return text5;}
  if (num == 6) {return text6;}
  return text0;}
//------------------------------------------------------------------------------------------------
//  Функция "Формирование переменной String по номеру"
//------------------------------------------------------------------------------------------------
String getTextSTR(uint8_t num) {
  if (num == 0) {return "Начало";}
  if (num == 1) {return "FLProg";}
  if (num == 2) {return "Успех";}
  if (num == 3) {return "KaScada";}
  if (num == 4) {return "ESP32";}
  if (num == 5) {return "EIS";}
  if (num == 6) {return "AH CCCP";}
  return " ";}
