//=================================================================================================
//								ОПРЕДЕЛЕНИЯ ПЕРЕЧИСЛЕНИЙ, ИМЕЮЩИХ ЗНАЧЕНИЯ 
// 								ДЛЯ ИДЕНТИФИКАЦИИ И ОПИСАНИИ КОНТРОЛЛЕРОВ 
//=================================================================================================
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Индексы массивов хранящихся в PGM
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum{RT_HW_PGM_SYS_PAR_ID,  RT_HW_PGM_SYS_ADC_ID,	RT_HW_PGM_SYS_TCH_ID,	RT_HW_PGM_SYS_PWM_ID,	RT_HW_PGM_SYS_DAC_ID,
//-------------------------------------------------------------------------------------------------	 
	 RT_HW_PGM_SYS_PIN_ID,
	 RT_HW_PGM_PIN_I2C_ID,  RT_HW_PGM_PIN_SPI_ID,	RT_HW_PGM_PIN_UHS_ID,	RT_HW_PGM_PIN_USS_ID,
	 RT_HW_PGM_PIN_CAN_ID,	RT_HW_PGM_PIN_BTH_ID,	RT_HW_PGM_PIN_ETH_ID,	RT_HW_PGM_PIN_WFI_ID,
//-------------------------------------------------------------------------------------------------
     RT_HW_PGM_PIN_ALL_ID,	RT_HW_PGM_PIN_DIN_ID,	RT_HW_PGM_PIN_ADC_ID,	RT_HW_PGM_PIN_TCH_ID,
	 RT_HW_PGM_PIN_DOT_ID,	RT_HW_PGM_PIN_PWM_ID,	RT_HW_PGM_PIN_DAC_ID,	RT_HW_PGM_PIN_INT_ID, 
	 RT_HW_PGM_PIN_N5V_ID,
//-------------------------------------------------------------------------------------------------
	 RT_HW_PGM_PIN_DBG_ID,	RT_HW_PGM_PIN_OUT_ID,	RT_HW_PGM_PIN_INP_ID, 
	 RT_HW_PGM_PIN_DCT_ID,	RT_HW_PGM_PIN_DEV_ID,	RT_HW_PGM_PIN_CSS_ID,	
	 RT_HW_PGM_PIN_LC6_ID,	RT_HW_PGM_PIN_SSP_ID,   RT_HW_PGM_ADR_I2C_ID,
//-------------------------------------------------------------------------------------------------	 
	 RT_HW_PGM_QNT_ID,		RT_HW_PGM_END=-2 }; 	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Идентификаторы скоростей UART (аппаратный и программный);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum  {RT_HW_UART_SPEED_HS=115200, RT_HW_UART_SPEED_SS=9600};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Параметры для работы с шиной i2c 
//	1. Коды битов слова состояния(STATE - device.i2cx.state); 
//	2. Коды скоростей шины i2c;
//  3. Скорости шины i2c (соответствуют кодам скоросте); 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum {RT_HW_I2C_STATE_INIT=0, RT_HW_I2C_STATE_SLAVE=1, RT_HW_I2C_STATE_BUSY=7};
enum {RT_HW_I2C_MODE_LOW=0, RT_HW_I2C_MODE_ST, RT_HW_I2C_MODE_FM, RT_HW_I2C_MODE_FM1, RT_HW_I2C_MODE_FM2,
	  RT_HW_I2C_MODE_FMP,   RT_HW_I2C_MODE_HS, RT_HW_I2C_MODE_UFM}; 	
enum {RT_HW_I2C_SPEED_LOW=  10000UL, RT_HW_I2C_SPEED_ST= 100000UL, 
	  RT_HW_I2C_SPEED_FM=  400000UL, RT_HW_I2C_SPEED_FM1=600000UL, RT_HW_I2C_SPEED_FM2= 600000UL,
	  RT_HW_I2C_SPEED_FMP=1000000UL, RT_HW_I2C_SPEED_HS=3400000UL, RT_HW_I2C_SPEED_UFM=5000000UL};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						Коды идентификаторов 
//					поддерживаемых архитектур контроллеров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum {RT_HW_ARCH_ANON_ID=0,  		RT_HW_ARCH_AVR_ID,     		RT_HW_ARCH_SAM_ID,     
      RT_HW_ARCH_ESP8266_ID, 		RT_HW_ARCH_ESP32_ID, 
      RT_HW_ARCH_STM32F1_ID, 		RT_HW_ARCH_STM32F4_ID, 		RT_HW_ARCH_STM32H7_ID};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						Коды идентификаторов 
//					поддерживаемых типов контроллеров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	  
enum {RT_HW_BOARD_AVR_ANON_ID=0}; 			
//----AVR------------------------------------------------------------------------------------------
enum {RT_HW_BOARD_AVR_UNO_ID=1, RT_HW_BOARD_AVR_NANO_ID, RT_HW_BOARD_AVR_PRO_ID, RT_HW_BOARD_AVR_MEGA2560_ID};	
//----ESP8266--------------------------------------------------------------------------------------	  
enum {RT_HW_BOARD_ESP8266_GENERIC_ID=10,    RT_HW_BOARD_ESP8266_NODEMCU_ID, 
      RT_HW_BOARD_ESP8266_WEMOS_D1_MINI_ID, RT_HW_BOARD_ESP8266_WEMOS_D1R1_ID}; 
//----ESP32----------------------------------------------------------------------------------------	   
enum {RT_HW_BOARD_ESP32_DEV_ID=20,         RT_HW_BOARD_ESP32_LOLIN_D32_ID, 
      RT_HW_BOARD_ESP32_LOLIN_D32_PRO_ID,  RT_HW_BOARD_ESP32_M5_STACK_CORE_ID, 
	  RT_HW_BOARD_ESP32_D1_MINI_32_ID}; 	
//----SAM------------------------------------------------------------------------------------------  
enum {RT_HW_BOARD_SAM_DUE_ID=30};
//----SEEEDUINO_XIAO_M0---------------------------------------------------------------------------- 
enum {RT_HW_BOARD_SEEED_XIAO_M0_ID=35};  
//---STM32MASTER F1-------------------------------------------------------------------------------	  
enum {RT_HW_BOARD_STM32MASTER_F1_GENERIC_STM32F103C_ID=40, 
	  RT_HW_BOARD_STM32MASTER_F1_GENERIC_STM32F103R_ID,	
      RT_HW_BOARD_STM32MASTER_F1_GENERIC_STM32F103V_ID};
//---STM32DUINO F1---------------------------------------------------------------------------------	 	  
enum {RT_HW_BOARD_STM32DUINO_F1_GENERIC_STM32F103C_ID=50, 
      RT_HW_BOARD_STM32DUINO_F1_GENERIC_STM32F103R_ID,	
      RT_HW_BOARD_STM32DUINO_F1_GENERIC_STM32F103V_ID,
      RT_HW_BOARD_STM32DUINO_F1_BLUEPILL_F103C_ID,	    	
      RT_HW_BOARD_STM32DUINO_F1_BLACKPILL_F103C_ID};   
//---STM32MASTER F4--------------------------------------------------------------------------------	  
enum {RT_HW_BOARD_STM32MASTER_F4_GENERIC_F407V_ID=60,		
      RT_HW_BOARD_STM32MASTER_F4_GENERIC_F407V_MINI_ID,  
      RT_HW_BOARD_STM32MASTER_F4_BLACKPILL_F401_ID,	
      RT_HW_BOARD_STM32MASTER_F4_DISCO_F411_ID};
//---STM32DUINO F4---------------------------------------------------------------------------------	   
enum {RT_HW_BOARD_STM32DUINO_F4_BLACK_F407XX_ID=70,      
      RT_HW_BOARD_STM32DUINO_F4_BLACKPILL_F401CC_ID,	
      RT_HW_BOARD_STM32DUINO_F4_BLACKPILL_F411CE_ID}; 
//---STM32DUINO H7---------------------------------------------------------------------------------	 	  
enum {RT_HW_BOARD_STM32DUINO_H7_DAISY_SEED_ID=80,		
      RT_HW_BOARD_STM32DUINO_F7_DISCO_F746NG_ID};	
//-------------------------------------------------------------------------------------------------
	  
//=================================================================================================
//								ИДЕНТИФИКАЦИЯ КОНТРОЛЛЕРОВ
//=================================================================================================  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								1. АРХИТЕКТУРА AVR
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------Arduino UNO-----------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_AVR_UNO) 	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_AVR_UNO_ID							//--Идентификатор выбора платы;
#define                      RT_HW_BOARD_AVR_UNO     						//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "standart"  									//--Название файла variant;
#define RT_HW_BOARD_NAME     "Arduino UNO"									//--Название платы;
#define RT_HW_BOARD_MEMORY	 "FLASH=32Kb,RAM=2Kb,EEPROM=1Kb"				//--Параметры памяти;
#define RT_HW_ARCH_AVR		 												//--Идентификатор архитектуры;
enum   {RT_HW_BOARD_CONTROL=10, RT_HW_BOARD_LED=13, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#endif
//---------------------------Arduino Nano----------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_AVR_NANO) 	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_AVR_NANO_ID						//--Идентификатор выбора платы;
#define                      RT_HW_BOARD_AVR_NANO    						//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "eightanaloginputs"							//--Название файла variant
#define RT_HW_BOARD_NAME	 "Arduino Nano"									//--Название платы;
#define RT_HW_BOARD_MEMORY   "FLASH=32Kb,RAM=2Kb,EEPROM=1Kb"				//--Параметры памяти;
#define RT_HW_ARCH_AVR		 												//--Идентификатор архитектуры;
enum   {RT_HW_BOARD_CONTROL=10, RT_HW_BOARD_LED=13, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#endif
//---------------------------Arduino Pro or Pro Mini-----------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_AVR_PRO) 	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_AVR_PRO_ID							//--Идентификатор выбора платы;
#define                      RT_HW_BOARD_AVR_PRO	    					//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "eightanaloginputs"							//--Название файла variant;
#define RT_HW_BOARD_NAME     "Arduino Pro or Pro Mini"						//--Название платы;
#define RT_HW_BOARD_MEMORY	 "FLASH=32Kb,RAM=2Kb,EEPROM=1Kb"				//--Параметры памяти;
#define RT_HW_ARCH_AVR		 												//--Идентификатор архитектуры;
enum   {RT_HW_BOARD_CONTROL=10, RT_HW_BOARD_LED=13, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#endif
//---------------------------Arduino Mega 2560-----------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_AVR_MEGA2560) 	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_AVR_MEGA2560_ID					//--Идентификатор выбора платы;
#define                      RT_HW_BOARD_AVR_MEGA2560 						//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "mega" 										//--Название файла variant;
#define RT_HW_BOARD_NAME	 "Arduino Mega or Mega2560"						//--Название платы
#define RT_HW_BOARD_MEMORY	 "FLASH=256Kb,RAM=8Kb,EEPROM=4Kb"				//--Параметры памяти;
#define RT_HW_ARCH_AVR														//--Идентификатор архитектуры;
enum   {RT_HW_BOARD_CONTROL=42, RT_HW_BOARD_LED=13, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#endif
//-------------------------------------------------------------------------------------------------
//							ОБЩЕЕ ДЛЯ КОНТРОЛЛЕРОВ АРХИТЕКТУРЫ AVR
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_AVR)
#define 	RT_HW_ARCH_PERMIT_availableForWrite	 //--Разрешено использование функции Serailx.availableForWrite;
#define		RT_HW_ARCH_PERMIT_WireSlave			 //--Разрешено использование в режиме i2c Slave;
#endif	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								2. АРХИТЕКТУРА ESP8266
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------Generic ESP8666 Module------------------------------------------------
// Определено в variant: A0=17;
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_ESP8266_GENERIC) 	
enum	{D0=16, D1=5, D2=4, D3=0, D4=2, D5=14, D6=12, D7=13, D8=15, D9=3, D10=1}; //--Обозначение пинов;
enum	{RX=3,  RX0=3, TX=1, TX0=1, TX1=2, RX2=13, TX2=15};					//--Обозначение пинов;
#define RT_HW_BOARD_DEFINED	 RT_HW_BOARD_ESP8266_GENERIC_ID					//--Идентификатор выбора платы;
#define                      RT_HW_BOARD_ESP8266_GENERIC  					//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "generic"										//--Название файла variant
#define RT_HW_BOARD_NAME	 "Generic ESP8266 Module"						//--Название платы;
#define RT_HW_BOARD_MEMORY	 "FLASH=FS:(max)2Mb,OTA:(max)1019Kb; RAM=80Kb"	//--Параметры памяти;
#define RT_HW_ARCH_ESP8266													//--Идентификатор архитектуры;
enum    {RT_HW_BOARD_CONTROL=D0, RT_HW_BOARD_LED=D4, RT_HW_BOARD_BUTTON=-1};//--Пины контроль,led,кнопка;
#define	RT_HW_BOARD_NAME_PINS_ESP8266_1 "D0=16, D1=5, D2=4, D3=0, D4=2, D5=14, D6=12, D7=13, D8=15, D9=3, D10=1, A0=17;"
#define	RT_HW_BOARD_NAME_PINS_ESP8266_2 "RX=3, TX=1, RX0=3, TX0=1, TX1=2, RX2=13, TX2=15;"
#endif
//---------------------------NodeMCU---------------------------------------------------------------
// Определено в variant: D0=16; D1=5; D2=4; D3=0; D4=2; D5=14; D6=12; D7=13; D8=15; D9=3; D10=1; A0=17;
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_ESP8266_NODEMCU) 	
enum	{RX=3, RX0=3, TX=1, TX0=1, TX1=2, RX2=13, TX2=15};					//--Обозначение пинов;
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_ESP8266_NODEMCU_ID					//--Идентификатор выбора платы;
#define  				     RT_HW_BOARD_ESP8266_MODEMCU    				//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT  "nodemcu"										//--Название файла variant
#define RT_HW_BOARD_NAME	 "NodeMCU 0.9 or 1.0(ESP-12 Module)"			//--Название платы;
#define RT_HW_BOARD_MEMORY	 "FLASH=FS:64Kb,OTA:512Kb; RAM=80Kb"			//--Параметры памяти;
#define RT_HW_ARCH_ESP8266													//--Идентификатор архитектуры;
enum   {RT_HW_BOARD_CONTROL=D0, RT_HW_BOARD_LED=D4, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#define RT_HW_BOARD_NAME_PINS_ESP8266_1 "D0=16, D1=5, D2=4, D3=0, D4=2, D5=14, D6=12, D7=13, D8=15, D9=3, D10=1, A0=17;"
#define RT_HW_BOARD_NAME_PINS_ESP8266_2 "RX=3, TX=1, RX0=3, TX0=1, TX1=2, RX2=13, TX2=15;"
#endif	
//---------------------------LOLIN(WEMOS)----------------------------------------------------------
//  Определено в variant: D0=16; D1=5; D2=4; D3=0; D4=2; D5=14; D6=12; D7=13; D8=15; RX=3; TX=1; 
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_ESP8266_WEMOS_D1MINI) ||\
                                      defined(ARDUINO_ESP8266_WEMOS_D1MINIPRO)||\
                                      defined(ARDUINO_ESP8266_WEMOS_D1MINILITE))
enum	{D9=3, D10=1, RX0=3, TX0=1, TX1=2, RX2=13, TX2=15};					//--Обозначение пинов;
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_ESP8266_WEMOS_D1_MINI_ID 			//--Идентификатор выбора платы;
#define    					 RT_HW_BOARD_ESP8266_WEMOS_D1_MINI				//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT  "d1_mini"										//--Название файла variant;
#define RT_HW_BOARD_NAME	 "WEMOS_D1MINI (PRO,LITE)"						//--Название платы;
#define RT_HW_BOARD_MEMORY	 "FLASH=FS:64Kb,OTA:512Kb; RAM=80Kb"			//--Параметры памяти;
#define RT_HW_ARCH_ESP8266													//--Идентификатор архитектуры;
#define RT_HW_BOARD_NAME_PINS_ESP8266_1 "D0=16, D1=5, D2=4, D3=0, D4=2, D5=14, D6=12, D7=13, D8=15, D9=3, D10=1, A0=17;"
#define RT_HW_BOARD_NAME_PINS_ESP8266_2 "RX=3, TX=1, RX0=3, TX0=1, TX1=2, RX2=13, TX2=15;"
enum   {RT_HW_BOARD_CONTROL=D0, RT_HW_BOARD_LED=D4, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#endif	
//---------------------------Wemos D1 R1-----------------------------------------------------------
//  Определено в variant: D0=3; D1=1; D2=16; D3=5; D4=4; D5=14; D6=12; D7=13; D8=0; D9=2; D10=15; 
//                        D11=13; D12=12; D13=14; D14=4; D15=5;
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_ESP8266_WEMOS_D1R1) 	
enum    {RX=3, RX0=3, TX=1, TX0=1, TX1=2, RX2=13, TX2=15};             		//--Обозначение пинов;
#define RT_HW_BOARD_DEFINED	 RT_HW_BOARD_ESP8266_WEMOS_D1R1_ID				//--Идентификатор выбора платы;
#define                      RT_HW_BOARD_ESP8266_WEMOS_D1R1					//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT "d1"											//--Название файла variant;
#define RT_HW_BOARD_NAME	 "Wemos D1 R1 (as UNO)"							//--Название платы;
#define RT_HW_BOARD_MEMORY	 "FLASH=FS:64Kb,OTA:512Kb; RAM=80Kb"			//--Параметры памяти;
#define RT_HW_ARCH_ESP8266													//--Идентификатор архитектуры;
#define RT_HW_BOARD_NAME_PINS_ESP8266_1 "D0=3, D1=1, D2=16, D3=5, D4=4, D5=14, D6=12, D7=13, D8=0, D9=2, D10=15, A0=17;"
#define RT_HW_BOARD_NAME_PINS_ESP8266_2 "D11=13; D12=12; D13=14; D14=4, D15=5, RX=3, TX=1, RX0=3, TX0=1, TX1=2, RX2=13, TX2=15;"
enum    {RT_HW_BOARD_CONTROL=D0, RT_HW_BOARD_LED=D4, RT_HW_BOARD_BUTTON=-1};//--Пины контроль,led,кнопка;
#endif	
//-------------------------------------------------------------------------------------------------
//							ОБЩЕЕ ДЛЯ КОНТРОЛЛЕРОВ АРХИТЕКТУРЫ ESP8266
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_ESP8266)
#define  	RT_HW_ARCH_PERMIT_availableForWrite	 //--Разрешено использование функции Serailx.availableForWrite;
#define 	RT_HW_ARCH_PERMIT_WireSlave			 //--Разрешено использование в режиме i2c Slave;
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								3. АРХИТЕКТУРА ESP32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------ESP32 DEV Module------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_ESP32_DEV)	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_ESP32_DEV_ID						//--Идентификатор выбора платы;
#define                      RT_HW_BOARD_ESP32_DEV							//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "esp32"										//--Название файла variant;
#define RT_HW_BOARD_NAME     "ESP32 Dev Module or ESP32 Wrover Module"		//--Название платы;
#define RT_HW_BOARD_MEMORY   "FLASH=1310Kb; RAM=328Kb, Ext_FLASH=4-16Mb"	//--Параметры памяти;
#define RT_HW_ARCH_ESP32													//--Идентификатор архитектуры;
enum    {RT_HW_BOARD_CONTROL=32, RT_HW_BOARD_LED=2, RT_HW_BOARD_BUTTON=-1};//--Пины контроль,led,кнопка;
#endif	
//---------------------------LOLIN D32-------------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_LOLIN_D32)	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_ESP32_LOLIN_D32_ID					//--Идентификатор выбора платы;
#define                      RT_HW_BOARD_ESP32_LOLIN_D32					//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "d32"											//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "LOLIN D32"									//--Название платы;
#define RT_HW_BOARD_MEMORY  "FLASH=1310Kb; RAM=328Kb, Ext_FLASH=4-16Mb"		//--Параметры памяти;
#define RT_HW_ARCH_ESP32													//--Идентификатор архитектуры;
enum    {RT_HW_BOARD_CONTROL=32, RT_HW_BOARD_LED=2, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#endif	
//---------------------------LOLIN D32_PRO---------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_LOLIN_D32_PRO)	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_ESP32_LOLIN_D32_PRO_ID				//--Идентификатор выбора платы;
#define  					 RT_HW_BOARD_ESP32_LOLIN_D32_PRO	 			//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "d32_pro"										//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "LOLIN D32 PRO"								//--Название платы;
#define RT_HW_BOARD_MEMORY   "FLASH=1310Kb; RAM=328Kb, Ext_FLASH=4-16Mb"	//--Параметры памяти;
#define RT_HW_ARCH_ESP32													//--Идентификатор архитектуры;
enum    {RT_HW_BOARD_CONTROL=32, RT_HW_BOARD_LED=2, RT_HW_BOARD_BUTTON=-1}; //--Пины контроль,led,кнопка;
#endif	
//---------------------------M5Stack-Core-ESP32----------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_M5Stack_Core_ESP32)	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_ESP32_M5_STACK_CORE_ID				//--Идентификатор выбора платы;
#define                      RT_HW_BOARD_ESP32_M5_STACK_CORE	 			//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "m5stack_core_esp32"							//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "M5Stack-Core-ESP32"							//--Название платы;
#define RT_HW_BOARD_MEMORY  "FLASH=1310Kb; RAM=328Kb, Ext_FLASH=4-16Mb"		//--Параметры памяти;
#define RT_HW_ARCH_ESP32													//--Идентификатор архитектуры;
enum    {RT_HW_BOARD_CONTROL=32, RT_HW_BOARD_LED=2, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#endif
//---------------------------WEMOS D1 MINI ESP32-----------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_D1_MINI32)	
#define RT_HW_BOARD_DEFINED	 RT_HW_BOARD_ESP32_D1_MINI_32_ID				//--Идентификатор выбора платы
#define						 RT_HW_BOARD_ESP32_D1_MINI_32 					//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "d1_mini32"									//--Название файла variant
#define RT_HW_BOARD_NAME  	 "WEMOS D1 MINI ESP32"							//--Название платы
#define RT_HW_BOARD_MEMORY   "FLASH=1310Kb; RAM=328Kb, Ext_FLASH=4-16Mb"	//--Параметры памяти;
#define RT_HW_ARCH_ESP32													//--Идентификатор архитектуры;
enum    {RT_HW_BOARD_CONTROL=32, RT_HW_BOARD_LED=2, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#endif
//-------------------------------------------------------------------------------------------------
//							ОБЩЕЕ ДЛЯ КОНТРОЛЛЕРОВ АРХИТЕКТУРЫ ESP32
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_ESP32)
#define 	RT_HW_ARCH_PERMIT_availableForWrite	 //--Разрешено использование функции Serailx.availableForWrite;
//#defined	RT_HW_ARCH_PERMIT_WireSlave			 //--Разрешено использование в режиме i2c Slave;
#endif


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ИДЕНТИФИКАТОР АРХИТЕКТУР
//                              ESP8266 или ESP32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_ESP8266) ||  defined(RT_HW_ARCH_ESP32)
#define RT_HW_ARCH_ESP
#endif
//-------------------------------------------------------------------------------------------------





//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 4.АРХИТЕКТУРА SAM3
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------Arduino DUE-----------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_SAM_DUE) 	
#define RT_HW_BOARD_DEFINED	 RT_HW_BOARD_SAM_DUE_ID							//--Идентификатор выбора платы
#define                      RT_HW_BOARD_SAM_DUE							//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "arduino_due_x"				  				//--Название файла variant
#define RT_HW_BOARD_NAME	 "Arduino DUE"									//--Название платы
#define RT_HW_BOARD_MEMORY   "FLASH=512Kb,RAM=96Kb"							//--Параметры памяти;
#define RT_HW_ARCH_SAM														//--Идентификация архитектуры платы;
enum   {RT_HW_BOARD_CONTROL=42, RT_HW_BOARD_LED=13, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#endif
//-------------------------------------------------------------------------------------------------
//							ОБЩЕЕ ДЛЯ КОНТРОЛЛЕРОВ АРХИТЕКТУРЫ SAM3
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_SAM)
#define 	RT_HW_ARCH_PERMIT_availableForWrite	 //--Разрешено использование функции Serailx.availableForWrite;
#define		RT_HW_ARCH_PERMIT_WireSlave			 //--Разрешено использование в режиме i2c Slave;
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 5.АРХИТЕКТУРА SEEEDUINO
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------Arduino SEEEDUINO XIAO M0---------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && defined(ARDUINO_SEEED_XIAO_M0) 	
#define RT_HW_BOARD_DEFINED	 RT_HW_BOARD_SEEED_XIAO_M0_ID					//--Идентификатор выбора платы
#define                      RT_HW_BOARD_SEEED_XIAO_M0						//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "Seeeduino XIAO M0"				  			//--Название файла variant
#define RT_HW_BOARD_NAME	 "Seeed XIAO M0"								//--Название платы
#define RT_HW_BOARD_MEMORY   "FLASH=256Kb,RAM=32Kb"							//--Параметры памяти;
#define RT_HW_ARCH_SEEEDUINO												//--Идентификация архитектуры платы;
enum   {RT_HW_BOARD_CONTROL=3, RT_HW_BOARD_LED=13, RT_HW_BOARD_BUTTON=-1};	//--Пины контроль,led,кнопка;
#endif
//-------------------------------------------------------------------------------------------------
//							ОБЩЕЕ ДЛЯ КОНТРОЛЛЕРОВ АРХИТЕКТУРЫ SEEEDUINO
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_SEEEDUINO)
#define 	RT_HW_ARCH_PERMIT_availableForWrite	 //--Разрешено использование функции Serailx.availableForWrite;
#define		RT_HW_ARCH_PERMIT_WireSlave			 //--Разрешено использование в режиме i2c Slave;
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 5.АРХИТЕКТУРА STM32F1->STM32-Master
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------Generic STM32F103C series---------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_GENERIC_STM32F103C))	
#define RT_HW_BOARD_DEFINED	 RT_HW_BOARD_STM32MASTER_F1_GENERIC_STM32F103C_ID //--Идентификатор выбора платы;
#define		                 RT_HW_BOARD_STM32MASTER_F1_GENERIC_STM32F103C	//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "generic_stm32f103c"							//--Название файла variant
#define RT_HW_BOARD_NAME  	 "Generic STM32F103C(B) series"					//--Название платы;
#define RT_HW_BOARD_MEMORY 	 "FLASH=128Kb; RAM=20Kb;"						//--Параметры памяти;
#define RT_HW_ARCH_STM32F1													//--Идентификатор архитектуры;
#define RT_HW_ARCH_STM32MASTER												//--Идентификатор ядра; 
#define RT_HW_DISABLE_JTAG_PINS	        //--Идентификатор разрешения испоьзования пинов JTAG(PA15,PB3,PB4);
enum   {RT_HW_BOARD_CONTROL=PB5,RT_HW_BOARD_LED=PC13,RT_HW_BOARD_BUTTON=PA1};//--Пины контроль,led,кнопка;

#endif
//---------------------------Generic STM32F103R series---------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_GENERIC_STM32F103R))	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_STM32MASTER_F1_GENERIC_STM32F103R_ID	//--Идентификатор выбора платы;
#define	                     RT_HW_BOARD_STM32MASTER_F1_GENERIC_STM32F103R	//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "generic_stm32f103r"							//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "Generic STM32F103R(8,B,C,E) series"			//--Название платы;
#define RT_HW_BOARD_MEMORY 	 "FLASH=512Kb; RAM=64Kb;"						//--Параметры памяти;
#define RT_HW_ARCH_STM32F1													//--Идентификатор архитектуры;
#define RT_HW_ARCH_STM32MASTER												//--Идентификатор ядра; 
enum   {RT_HW_BOARD_CONTROL=PC2,RT_HW_BOARD_LED=PB11,RT_HW_BOARD_BUTTON=PA1};//--Пины контроль,led,кнопка;
#endif
//---------------------------Generic STM32F103V series---------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_GENERIC_STM32F103V))	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_STM32MASTER_F1_GENERIC_STM32F103V_ID //--Идентификатор выбора платы;
#define	                     RT_HW_BOARD_STM32MASTER_F1_GENERIC_STM32F103V	//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "generic_stm32f103v"							//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "Generic STM32F103V(B,C,D,E) series"			//--Название платы;
#define RT_HW_BOARD_MEMORY 	 "FLASH=512Kb; RAM=64Kb;"					    //--Параметры памяти;
#define RT_HW_ARCH_STM32F1													//--Идентификатор архитектуры;
#define RT_HW_ARCH_STM32MASTER												//--Идентификатор ядра; 
enum   {RT_HW_BOARD_CONTROL=PC2,RT_HW_BOARD_LED=PB12,RT_HW_BOARD_BUTTON=PA1};//--Пины контроль,led,кнопка;
#endif
//-------------------------------------------------------------------------------------------------
//							ОБЩЕЕ ДЛЯ КОНТРОЛЛЕРОВ АРХИТЕКТУРЫ STM32F1->STM32-Master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32F1) && defined(RT_HW_ARCH_STM32MASTER)	
#define 	RT_HW_ARCH_PERMIT_availableForWrite	 //--Разрешено использование функции Serailx.availableForWrite;
#define	    RT_HW_ARCH_PERMIT_WireSlave			 //--Разрешено использование в режиме i2c Slave;
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 6.АРХИТЕКТУРА STM32F1->STM32duino
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------GENERIC_STM32F103C(8,B)-----------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_GENERIC_STM32F103C8) ||\
                                      defined(ARDUINO_GENERIC_STM32F103CB))	
#define	RT_HW_BOARD_DEFINED	 RT_HW_BOARD_STM32DUINO_F1_GENERIC_STM32F103C_ID//--Идентификатор выбора платы
#define		                 RT_HW_BOARD_STM32DUINO_F1_GENERIC_STM32F103C	//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "Generic_F103Cx"								//--Название файла variant
#define RT_HW_BOARD_NAME  	 "GENERIC_STM32F103C(8,B)"						//--Название платы
#define RT_HW_BOARD_MEMORY 	 "FLASH=128Kb; RAM=20Kb;"						//--Параметры памяти;
#define RT_HW_ARCH_STM32F1													//--Идентификация архитектуры платы;
#define RT_HW_ARCH_STM32DUINO												//--Идентификатор  
enum   {RT_HW_BOARD_CONTROL=PB5,RT_HW_BOARD_LED=PC13 RT_HW_BOARD_BUTTON=PA1};//--Пины контроль,led,кнопка;
#endif
//---------------------------GENERIC_STM32F103R----------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_GENERIC_STM32F103R8) || defined(ARDUINO_GENERIC_STM32F103RB) ||\
                                      defined(ARDUINO_GENERIC_STM32F103RC) || defined(ARDUINO_GENERIC_STM32F103RD) ||\
									  defined(ARDUINO_GENERIC_STM32F103RE) || defined(ARDUINO_GENERIC_STM32F103RF) ||\
									  defined(ARDUINO_GENERIC_STM32F103RG))
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_STM32DUINO_F1_GENERIC_STM32F103R_ID //--Идентификатор выбора платы
#define                      RT_HW_BOARD_STM32DUINO_F1_GENERIC_STM32F103R	//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "Generic_F103Rx"								//--Название файла variant
#define RT_HW_BOARD_NAME  	 "GENERIC_STM32F103R(8,B,C,D,E,F,G)"			//--Название платы
#define RT_HW_BOARD_MEMORY 	 "FLASH=512Kb; RAM=64Kb;"						//--Параметры памяти;
#define RT_HW_ARCH_STM32F1													//--Идентификация архитектуры платы;
#define RT_HW_ARCH_STM32DUINO												//--Идентификатор  
enum   {RT_HW_BOARD_CONTROL=PC2,RT_HW_BOARD_LED=PB11,RT_HW_BOARD_BUTTON=PA1};//--Пины контроль,led,кнопка;
#endif
//---------------------------GENERIC_STM32F103V----------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_GENERIC_STM32F103V8) || defined(ARDUINO_GENERIC_STM32F103VB) ||\
                                      defined(ARDUINO_GENERIC_STM32F103VC) || defined(ARDUINO_GENERIC_STM32F103VD) ||\
									  defined(ARDUINO_GENERIC_STM32F103VE) || defined(ARDUINO_GENERIC_STM32F103VF) ||\
									  defined(ARDUINO_GENERIC_STM32F103VG))
#define RT_HW_BOARD_DEFINED	 RT_HW_BOARD_STM32DUINO_F1_GENERIC_STM32F103V_ID//--Идентификатор выбора платы
#define                      RT_HW_BOARD_STM32DUINO_F1_GENERIC_STM32F103V	//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "Generic_F103Vx"								//--Название файла variant
#define RT_HW_BOARD_NAME  	 "GENERIC_STM32F103V(8,B,C,D,E,F,G)"			//--Название платы
#define RT_HW_BOARD_MEMORY 	 "FLASH=512Kb; RAM=64Kb;"						//--Параметры памяти;
#define RT_HW_ARCH_STM32F1													//--Идентификация архитектуры;
#define RT_HW_ARCH_STM32DUINO												//--Идентификатор  
enum   {RT_HW_BOARD_CONTROL=PC2,RT_HW_BOARD_LED=PB11,RT_HW_BOARD_BUTTON=PA1};//--Пины контроль,led,кнопка;
#endif
//---------------------------BluePill_F103(8,B)----------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_BLUEPILL_F103C8) || defined(ARDUINO_BLUEPILL_F103CB))
#define RT_HW_BOARD_DEFINED	 RT_HW_BOARD_STM32DUINO_F1_BLUEPILL_F103C_ID	//--Идентификатор выбора платы
#define		                 RT_HW_BOARD_STM32DUINO_F1_BLUEPILL_F103C		//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "PILL_F103XX"									//--Название файла variant
#define RT_HW_BOARD_NAME  	 "BluePill_F103(8,B)"							//--Название платы
#define RT_HW_BOARD_MEMORY 	 "FLASH=128Kb; RAM=20Kb;"						//--Параметры памяти;
#define RT_HW_ARCH_STM32F1													//--Идентификация архитектуры платы;
#define	RT_HW_ARCH_STM32DUINO												//--Идентификатор ядра;  
enum   {RT_HW_BOARD_CONTROL=PB5,RT_HW_BOARD_LED=PC13,RT_HW_BOARD_BUTTON=PA1};//--Пины контроль,led,кнопка;
#endif
//---------------------------BlackPill_F103(8,B)-----------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_BLACKPILL_F103C8) || defined(ARDUINO_BLACKPILL_F103CB))
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_STM32DUINO_F1_BLACKPILL_F103C_ID	//--Идентификатор выбора платы
#define		                 RT_HW_BOARD_STM32DUINO_F1_BLACKPILL_F103C		//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "PILL_F103XX"									//--Название файла variant
#define RT_HW_BOARD_NAME  	 "BlackPill_F103(8,B)"							//--Название платы
#define RT_HW_BOARD_MEMORY 	 "FLASH=128Kb; RAM=20Kb;"					    //--Параметры памяти;
#define RT_HW_ARCH_STM32F1													//--Идентификация архитектуры платы;
#define RT_HW_ARCH_STM32DUINO												//--Идентификатор ядра;   
enum   {RT_HW_BOARD_CONTROL=PB5,RT_HW_BOARD_LED=PC13,RT_HW_BOARD_BUTTON=PA1};//--Пины контроль,led,кнопка;
#endif
//-------------------------------------------------------------------------------------------------
//							ОБЩЕЕ ДЛЯ КОНТРОЛЛЕРОВ АРХИТЕКТУРЫ STM32F1->STM32duino
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32F1) && defined(RT_HW_ARCH_STM32DUINO)	
#defined 	RT_HW_ARCH_PERMIT_availableForWrite	 //--Разрешено использование функции Serailx.availableForWrite;
#defined	RT_HW_ARCH_PERMIT_WireSlave			 //--Разрешено использование в режиме i2c Slave;
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 7.АРХИТЕКТУРА STM32F4->STM32-Master
// В ядре STM32-Master для контроллеров STM32F4 пока ограниченная поддержка контроллеров STM32F4
// Так STM32F407V нет поддержки WireSlave, Serialx.availableForWrite и др.
// Если ядро будет развиваться, в дальнейщем может быть добавлена поддержка 
// и ниже закоментированных контроллеров.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------Generic STM32F407V series---------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_generic_f407v) || defined(_BOARD_GENERIC_F407V_H_))	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_STM32MASTER_F4_GENERIC_F407V_ID	//--Идентификатор выбора платы;
#define		                 RT_HW_BOARD_STM32MASTER_F4_GENERIC_F407V		//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "generic_f407v"								//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "Generic STM32F407V series"					//--Название платы;
#define RT_HW_BOARD_MEMORY 	 "FLASH=512Kb; RAM=128Kb;"						//--Параметры памяти;
#define RT_HW_ARCH_STM32F4													//--Идентификатор архитектуры;
#define RT_HW_ARCH_STM32MASTER												//--Идентификатор ядра; 
enum   {RT_HW_BOARD_CONTROL=PA6,RT_HW_BOARD_LED=PA7,RT_HW_BOARD_BUTTON=PA0};//--Пины контроль,led,кнопка;
#endif
//---------------------------Generic STM32F407V mini series----------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_generic_f407v_mini))	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_STM32MASTER_F4_GENERIC_F407V_MINI_ID //--Идентификатор выбора платы;
#define	                     RT_HW_BOARD_STM32MASTER_F4_GENERIC_F407V_MINI	//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "generic_f407v_mini"							//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "Generic STM32F407V mini series"				//--Название платы;
#define RT_HW_BOARD_MEMORY 	 "FLASH=512Kb; RAM=128Kb;"						//--Параметры памяти;
#define RT_HW_ARCH_STM32F4													//--Идентификатор архитектуры;
#define RT_HW_ARCH_STM32MASTER												//--Идентификатор ядра; 
enum   {RT_HW_BOARD_CONTROL=PA6,RT_HW_BOARD_LED=PA7,RT_HW_BOARD_BUTTON=PA0};//--Пины контроль,led,кнопка;
#endif
//---------------------------Blackpill STM32F401CCU6-----------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_blackpill_f401))	
#define RT_HW_BOARD_DEFINED	 RT_HW_BOARD_STM32MASTER_F4_BLACKPILL_F401_ID	//--Идентификатор выбора платы;
#define		                 RT_HW_BOARD_STM32MASTER_F4_BLACKPILL_F401		//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "blackpill_f401"								//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "Blackpill STM32Ff401CCU6"						//--Название платы;
#define RT_HW_BOARD_MEMORY 	 "FLASH=256Kb; RAM=64Kb; OTP=512b;"				//--Параметры памяти;
#define RT_HW_ARCH_STM32F4													//--Идентификатор архитектуры;
#define RT_HW_ARCH_STM32MASTER												//--Идентификатор ядра;  
enum   {RT_HW_BOARD_CONTROL=PB5,RT_HW_BOARD_LED=PC13,RT_HW_BOARD_BUTTON=PA0};//--Пины контроль,led,кнопка;
#endif
//--------------------------STM32_Discovery F411E--------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_disco_f411))	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_STM32MASTER_F4_DISCO_F411_ID		//--Идентификатор выбора платы;
#define		                 RT_HW_BOARD_STM32MASTER_F4_DISCO_F411			//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "disco_f411"									//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "STM32_Discovery F411E"						//--Название платы;
#define RT_HW_BOARD_MEMORY 	 "FLASH=512Kb; RAM=128Kb;"						//--Параметры памяти;
#define RT_HW_ARCH_STM32F4													//--Идентификатор архитектуры платы;
#define RT_HW_ARCH_STM32MASTER												//--Идентификатор ядра; 
enum   {RT_HW_BOARD_CONTROL=PB5,RT_HW_BOARD_LED=PC13,RT_HW_BOARD_BUTTON=PA0};//--Пины контроль,led,кнопка;
#endif
//-------------------------------------------------------------------------------------------------
//							ОБЩЕЕ ДЛЯ КОНТРОЛЛЕРОВ АРХИТЕКТУРЫ STM32F4->STM32-Master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32F4) && defined(RT_HW_ARCH_STM32MASTER)	
//---Нет разрешения
//#define 	RT_HW_ARCH_PERMIT_availableForWrite	 //--Разрешено использование функции Serailx.availableForWrite;
//#define		RT_HW_ARCH_PERMIT_WireSlave			 //--Разрешено использование в режиме i2c Slave;
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 8.АРХИТЕКТУРА STM32F4->STM32duino
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//---------------------------Black F407V(E,G)------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_BLACK_F407VE) ||\
                                      defined(ARDUINO_BLACK_F407VG))	
#define RT_HW_BOARD_DEFINED	 RT_HW_BOARD_STM32DUINO_F4_BLACK_F407XX_ID		//--Идентификатор выбора платы;
#define		                 RT_HW_BOARD_STM32DUINO_F4_BLACK_F407XX			//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "BLACK_F407xx"									//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "Black F407V(E,G)"								//--Название платы;
#define RT_HW_BOARD_MEMORY 	 "FLASH=512Kb; RAM=192+4Kb; OTP=512b;"			//--Параметры памяти;
#define RT_HW_ARCH_STM32F4													//--Идентификатор архитектуры платы;
#define RT_HW_ARCH_STM32DUINO												//--Идентификатор ядра; 
enum   {RT_HW_BOARD_CONTROL=PA6,RT_HW_BOARD_LED=PA7,RT_HW_BOARD_BUTTON=PA0};//--Пины контроль,led,кнопка;
#endif
//---------------------------BlackPill F401CC------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_BLACKPILL_F401CC))	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_STM32DUINO_F4_BLACKPILL_F401CC_ID	//--Идентификатор выбора платы;
#define		                 RT_HW_BOARD_STM32DUINO_F4_BLACKPILL_F401CC		//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "Generic_F401Cx"								//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "BlackPill F401CC"								//--Название платы;
#define RT_HW_BOARD_MEMORY 	 "FLASH=256Kb; RAM=64Kb; OTP=512b;"			    //--Параметры памяти;
#define RT_HW_ARCH_STM32F4													//--Идентификатор архитектуры платы;
#define RT_HW_ARCH_STM32DUINO												//--Идентификатор ядра;  
enum   {RT_HW_BOARD_CONTROL=PB5,RT_HW_BOARD_LED=PC13,RT_HW_BOARD_BUTTON=PA0};//--Пины контроль,led,кнопка;
#endif
//---------------------------BlackPill F411CE------------------------------------------------------
#if !defined(RT_HW_BOARD_DEFINED) && (defined(ARDUINO_BLACKPILL_F411CE))	
#define RT_HW_BOARD_DEFINED  RT_HW_BOARD_STM32DUINO_F4_BLACKPILL_F411CE_ID	//--Идентификатор выбора платы;
#define		                 RT_HW_BOARD_STM32DUINO_F4_BLACKPILL_F411CE		//--Идентификатор платы;
#define RT_HW_BOARD_VARIANT	 "Generic_F411Cx"								//--Название файла variant;
#define RT_HW_BOARD_NAME  	 "BlackPill F411CE"								//--Название платы;
#define RT_HW_BOARD_MEMORY 	 "FLASH=512Kb; RAM=128Kb;"					     //--Параметры памяти;
#define RT_HW_ARCH_STM32F4													//--Идентификатор архитектуры;
#define RT_HW_ARCH_STM32DUINO												//--Идентификатор ядра;
enum   {RT_HW_BOARD_CONTROL=PB5,RT_HW_BOARD_LED=PC13,RT_HW_BOARD_BUTTON=PA0};//--Пины контроль,led,кнопка;
#endif
//-------------------------------------------------------------------------------------------------
//							ОБЩЕЕ ДЛЯ КОНТРОЛЛЕРОВ АРХИТЕКТУРЫ STM32F4->STM32duino
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32F4) && defined(RT_HW_ARCH_STM32DUINO)	
#define 	RT_HW_ARCH_PERMIT_availableForWrite	 //--Разрешено использование функции Serailx.availableForWrite;
#define	    RT_HW_ARCH_PERMIT_WireSlave			 //--Разрешено использование в режиме i2c Slave;
#endif


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 9.АРХИТЕКТУРА STM32F7->STM32duino
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------------------------------------------------------------------------
//							ОБЩЕЕ ДЛЯ КОНТРОЛЛЕРОВ АРХИТЕКТУРЫ STM32F4->STM32duino
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_ARCH_STM32F7) && defined(RT_HW_ARCH_STM32DUINO)	
//#defined 	RT_HW_ARCH_PERMIT_availableForWrite	 //--Разрешено использование функции Serailx.availableForWrite;
//#defined	RT_HW_ARCH_PERMIT_WireSlave			 //--Разрешено использование в режиме i2c Slave;
#endif



//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ИДЕНТИФИКАТОР АРХИТЕКТУР
//                      (или)STM32F1,STM32F4,STM32F7,STM32H7) 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_STM32F1) || defined(RT_HW_ARCH_STM32F4) || defined(RT_HW_ARCH_STM32F7) || defined(RT_HW_ARCH_STM32H7)
#define 	RT_HW_ARCH_STM32
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							99.НЕ ОПОЗНАННАЯ ПЛАТА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_DEFINED)  	
#define		 RT_HW_BOARD_DEFINED	RT_HW_BOARD_AVR_ANON_ID						//--Идентификатор выбора платы
#define		                        RT_HW_BOARD_AVR_ANON						//--Идентификатор платы;
#define		 RT_HW_BOARD_VARIANT	"standart"  								//--Название файла variant;
#define 	 RT_HW_BOARD_NAME		"Arduino ANON"								//--Название платы;
#define      RT_HW_BOARD_MEMORY		"FLASH=32Kb,RAM=2Kb,EEPROM=1Kb"				//--Параметры памяти;
//#define 	 RT_HW_ARCH_AVR														//--Идентификатор ядра;
enum		{RT_HW_BOARD_CONTROL=-1, RT_HW_BOARD_LED=-1, RT_HW_BOARD_BUTTON=-1};//--Пины контроль,led,кнопка;
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++