#include "RT_HW_HC_SR04.h"
//#include "RT_HW_Main.h"
bool control;
int16_t pinControl;
int16_t pinFast;
uint32_t timeStart;
float tC=25.3;
RT_HW_HC_SR04_ID id;
RT_HW_HC_SR04_ID id3;
uint16_t ageLenCm, LenCm;
uint16_t ageLenMm;
uint16_t ageLenMcs;
uint32_t timePrint=0;


//-------------------------------------------------------------------------------------------------
//    ОБРАБОТЧИК ПРЕРЫВАНИЙ СОНАРА HC-SR04
//-------------------------------------------------------------------------------------------------
void IRQ_handler(){
if(!id.start) return;
if(!id.begin)  { if( digitalRead(id.pinEcho)) {id.timeBegin=micros();  id.begin=true;}}
  else         { if(!digitalRead(id.pinEcho)) {id.timeEnd  =micros();   id.end  =true;  detachInterrupt(id.numIRQ);}}}
//=================================================================================================
void setup()
{
  Serial.begin(115200);
pinControl=38; pinFast=39;
pinMode(pinControl,OUTPUT); pinMode(pinFast,OUTPUT);

}
//===============================================================================================
void loop()
{ control=!control;  digitalWrite(pinControl, control);
  //------------------
//---ИНИЦИАЛИЗАЦИЯ (функция защищена от повторного  запуска флагом id.init) 
  RT_HW_hc_sr04.setDevice(id,4);   //id.period=50;
//---ЗАПУСК ИЗМЕРЕНИЯ
  if(RT_HW_hc_sr04.periodMillis(id.timePeriod,id.period)) {id.run=true;} 
//---ИЗМЕРЕНИЕ РАССТОЯНИЯ
//id.modeIRQ=0;
if (id.modeIRQ) {RT_HW_hc_sr04.meterYesIRQ(id); if(id.startIRQ) {id.startIRQ=false; attachInterrupt(id.numIRQ, IRQ_handler, CHANGE);}}
  else          {RT_HW_hc_sr04.meterNoIRQ(id);};
//---ВЫВОД РЕЗУЛЬТАТОВ
  if(id.fresh) {id.fresh=0; LenCm=RT_HW_hc_sr04.getLenghtCmAver(id);
  if(ageLenCm!=LenCm){ageLenCm=LenCm;
  Serial.println(String(F("#code=")) + String(id.code)+String(F(" mcs=")) + String(id.LenghtMcs) +  String(F(" cm=")) + String(id.LenghtMm/10) +  String(F(" cmAver=")) + String(LenCm) );
  }}
//-----------------
} 
