//*************************************************************************************************
//							1.Контроллеры типа ESP8226
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT) && (defined(RT_HW_BOARD_ESP8266_GENERIC)       ||\
                                     defined(RT_HW_BOARD_ESP8266_MODEMCU)       ||\
                                     defined(RT_HW_BOARD_ESP8266_WEMOS_D1_MINI) ||\
									 defined(RT_HW_BOARD_ESP8266_WEMOS_D1R1))								
#define 	 RT_HW_BOARD_SELECT	 "Board Select->ESP8266 Generic,NodeMCU, Wemos D1 mini, Wemos D1 R1" //--Идентификатор выбора; 
#define  	 RT_HW_BRD_ESP8266                            					//--Идентификатор выбора пинов и параметров; 
//-----Параметры контроллера общие-----------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=18,	RT_HW_FCPU=80, RT_HW_VCC=3300};
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=RX,  RT_HW_UART0_TX=TX,
		RT_HW_UART1_RX=-1,  RT_HW_UART1_TX=TX1};
enum   {RT_HW_UARTS_RX=RX2, RT_HW_UARTS_TX=TX2};		
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UART1
#define RT_HW_PERMIT_UARTS
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=SDA,  RT_HW_I2C0_SCL=SCL, RT_HW_I2C0_MODE_FM=RT_HW_I2C_MODE_FM};  
#define RT_HW_PERMIT_I2C0
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SS=D8,  RT_HW_SPI0_MOSI=D7,  RT_HW_SPI0_MISO=D6,  RT_HW_SPI0_SCK=D5};
#define RT_HW_PERMIT_SPI0
//-----Системные параметры-------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PAR) ={12,			 RT_HW_PGM_END};  //--SYS->depth;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PIN) ={D0,LED_BUILTIN,RT_HW_PGM_END};  //--Пины->control,led; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_ADC) ={10,3,4, 		 RT_HW_PGM_END};  //--ADC->depth,drift,null;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_TCH) ={          	 RT_HW_PGM_END};  //--TCH->depth,drift,null; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_PWM) ={10,10,         RT_HW_PGM_END};  //--PWM->depth,freq; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_SYS_DAC) ={          	 RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_I2C)	={RT_HW_I2C0_SDA, RT_HW_I2C0_SCL,		RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SPI)	={RT_HW_SPI0_SS,  RT_HW_SPI0_MOSI, RT_HW_SPI0_MISO, RT_HW_SPI0_SCK,	RT_HW_PGM_END}; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_UHS)	={RT_HW_UART0_RX, RT_HW_UART0_TX,  RT_HW_UART1_RX,  RT_HW_UART1_TX,	RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_USS)	={RT_HW_UARTS_RX, RT_HW_UARTS_TX,		RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CAN)	={										RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_BTH)	={										RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ETH)	={										RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_WFI)	={(int8_t)192,							RT_HW_PGM_END};	
//-----Доступные пины контроллера------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ALL)	={D0,D1,D2,D3,D4,D5,D6,D7,D8,D9,D10,A0,	RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DIN)	={-1,D1,D2,D3,D4,D5,D6,D7,D8,D9,D10,	RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_ADC)	={A0,									RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_TCH)	={										RT_HW_PGM_END};									
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DOT)	={D0,D1,D2,D3,D4,D5,D6,D7,D8, -1,-1,	RT_HW_PGM_END}; 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_PWM)	={-1,D1,D2,D3,D4,D5,D6,D7,D8, -1,-1,	RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DAC)	={										RT_HW_PGM_END};
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INT)	={-1,D1,D2,D3,D4,D5,D6,D7,D8, -1,-1,	RT_HW_PGM_END};	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_N5V)	={D0,D1,D2,D3,D4,D5,D6,D7,D8,D9,D10,A0,	RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DBG) ={	    		RT_HW_PGM_END};	// debug1,debug2,debug3;	
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_OUT)	={D8,-1,D0,     RT_HW_PGM_END};	// PWM0, PWM1, led,dev;							                  
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_INP)	={A0,-1,D4,     RT_HW_PGM_END};	// A0,   A1, btn1,btn2;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DCT)	={          	RT_HW_PGM_END};	// DAC0,DAC1,TCH0;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_DEV)	={			   	RT_HW_PGM_END};	// DS1820,DHT22,HC-SR04
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_CSS)	={				RT_HW_PGM_END};	// CS SPI:595,LCD,NRF,DEVl 
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_LC6) ={				RT_HW_PGM_END};	// Пины для подключения LCD по 4-х битной шине;
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_PIN_SSP) ={				RT_HW_PGM_END};	// Пины программного SPI;		
RT_HW_BUILD_INT8_PGM(RT_HW_PGM_ADR_I2C) ={39,62,32,33,	RT_HW_PGM_END};	// lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif
