****************  RT_LiquidCrystal ver1.2 *****************************
             LCD     

   HD44780, S6A0069, KS0066U, NT3881D, LC7985, ST7066, SPLC780,
  WH160xB, AIP31066, GDM200xD, ADM0802A LCD displays.
  
     Arduino Uno(*),Nano(*),Mini,Pro,Mega2560(*),
           Due,Leonardo, ATtiny85, ESP8266 ESP-01,NodeMCU 1.0, WeMos D1 Mini
  
   c LCD :
    1)  4-     ; !!!  
    2)   i2c  8-  I/O PCF8574.
  
    : 8x2, 16x1, 16x2, 16x4, 20x2, 20x4  .
  
    LCD   .

  i2c       
         SDA	SCL
  Uno, Mini, Pro:     A4	A5
  Mega2560, Due:      20	21
  Leonardo:	      2		3
  ATtiny85:	      0(5)	2/A1(7)   (ATTinyCore -  https://github.com/SpenceKonde/ATTinyCore
                                            & TinyWireM- https://github.com/SpenceKonde/TinyWireM)
  ESP8266 ESP-01:   GPIO0/D5	GPIO2/D3  (ESP8266Core - https://github.com/esp8266/Arduino)
  NodeMCU 1.0:      GPIO4/D2	GPIO5/D1
  WeMos D1 Mini:    GPIO4/D2	GPIO5/D1

  :
  1) LiquidCrystal Arduino library for the DFRobot LCD displays
  2) written by : enjoyneering79
     sourse code: https://github.com/enjoyneering/
******************************************************************
  //do {} while (!LcdRT.begin()); 
  //do {} while (!LcdRT.print(1,Line1)); 
  //do {} while (!LcdRT.print(0,1,Line1)); 
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            i2c 
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
1.  -   Wire.h()  Arduino  ESP8266  
          i2c     
        ,    Setup() 
        :
  ----------------------------------- 
    Arduino:
   Wire.begin();
   Wire.setClock(400000UL); //AVR i2c bus speed:AVR 31kHz..400kHz/31000UL..400000UL,
                            //  default 100000UL
  ----------------------------------- 
     ESP8266 ESP-01
   Wire.begin(5, 4);
   Wire.setClock(100000UL);//ESP8266 i2c bus speed: 100kHz..400kHz/100000UL..400000UL, 
                           //     100000UL
   Wire.setClockStretchLimit(230);  //experimental! default 230
  ----------------------------------- 
       ESP8266 - NodeMCU 1.0, WeMos D1 Mini  ..
   Wire.begin(2, 1);
   Wire.setClock(100000UL);//ESP8266 i2c bus speed: 100kHz..400kHz/100000UL..400000UL, 
                           //    100000UL
   Wire.setClockStretchLimit(230);  //experimental! default 230

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
             
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
//------  LCD           
   xxx.config_i2c (uint8_t addr,uint8_t cols,uint8_t rows); - , - , - 
   xxx.setPeriodModeStart(uint16_t start) -    start
   xxx.setPeriodModeAll (uint16_t start, uint16_t update, uint16_t hot) 
                                                           -   
//------  LCD    
   xxx.print(0,1,Line) =  ,  ,  

//------  LCD   .     . 
//               (  CRC8) 
//             Update
   xxx.print(1,Line) =  ,  
//------ 
   xxx.readErrorI2C() -       i2c (  LCD);
   xxx.readRows()     -  -   LCD
   xxx.readCols()     -  -   LCD
   xxx.readVer()      -   
   xxx.readModeStart()-   " start
   xxx.readModeUpdate()-    " update"
   xxx.readModeHot()  -   " hot"
   xxx.readOutLine()  -     (  .)
   xxx.readCRC8(uint8_t row)-  CRC8( )
   xxx.startLcd()	   -     LCD
   xxx.clearMode()    -   

   xxx.isTimer_mcs(uint32_t start_Time,uint32_t period )-   mcs
   xxx.isTimer    (uint32_t start_Time,uint32_t period )-   ms
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  -----------------------    RT ----------------------------- 
          
    Arduino FLProg (www.flprog.ru)    .
          
    RT (   ).  
  
     RT        (bool),
      ( )     
         false.
             
      true.
      delay()         .
  
    RT       ,  
      loop (    1,    10).
       (  )   - 
       . 
  -------------------------------------------------------------------------------------------------
  1.    enjoyneering79 (https://github.com/enjoyneering/),
         100%   enjoyneering79.
  2. https://github.com/enjoyneering/LiquidCrystal_I2C
  3. LiquidCrystal Arduino library for the DFRobot LCD displays
  4.  HD44780U (LCD-II) Hitachi (ADE-207-272(Z)  99.9 Rev.0.0
  -------------------------------------------------------------------------------------------------
  
    Arduino   Lcd HD44780, S6A0069, KS0066U, NT3881D, LC7985, ST7066,
  SPLC780, WH160xB, AIP31066, GDM200xD, ADM0802A LCD 
      i2c  8-bit I/O expander PCF8574x.
    : 8x2, 16x1, 16x2, 16x4, 20x2, 20x4 & etc.
        :

  Board:                                    SDA                    SCL                    Level
  Uno, Mini, Pro, ATmega168, ATmega328..... A4                     A5                     5v
  Mega2560................................. 20                     21                     5v
  ESP8266 ESP-01........................... GPIO0/D5               GPIO2/D3               3.3v/5v
  NodeMCU 1.0, WeMos D1 Mini............... GPIO4/D2               GPIO5/D1               3.3v/5v
  ESP32.................................... GPIO21/D21             GPIO22/D22             3.3v

  Frameworks & Libraries:
  ESP32 Core            - https://github.com/espressif/arduino-esp32
  ESP8266 Core          - https://github.com/esp8266/Arduino
  STM32 Core            - https://github.com/rogerclarkmelbourne/Arduino_STM32
  
#########################################################################################
/*****************  RT_LiquidCrystal ver1.2 ***********************************
  p    c LCD  HD44780
  p   Arduino Uno(*),Nano(*),Mini,Pro,Mega2560(*),
               Due,Leonardo, ESP8266 ESP-01,NodeMCU 1.0, WeMos D1 Mini
   c LCD   i2c  8-  I/O PCF8574.
  
    : 8x2, 16x1, 16x2, 16x4, 20x2, 20x4  .
    LCD   .
    ,        LCD   ,
        .
        ,     i2c.
      4-  (  #define)

******************************************************************
//--------------------------------------------------------------------------------------- 
//     
//--------------------------------------------------------------------------------------- 
#include "RT_Hardware.h"        //--          (AVR,ESP8266,ESP32,STM32)
#include <Wire.h>
#include "RT_LiquidCrystal.h"   //-- RT  Lcd  HD44780 
RT_LiquidCrystal lcd;           //-- Lcd
//--------------------------------------------------------------------------------------- 
//     Wire.h (  ESP8266)
//---------------------------------------------------------------------------------------
  lcd.wirePins(4,5);
  Wire.begin();
  Wire.setClock(400000UL);  
//--------------------------------------------------------------------------------------- 
//   RT_LiquidCrystal_ID_XXX -         
//--------------------------------------------------------------------------------------- 
 RT_LiquidCrystal_ID_CHAR  -         char 
 RT_LiquidCrystal_ID_INT16  -        int16_t
 RT_LiquidCrystal_ID_FLOAT  -        float
 RT_LiquidCrystal_ID_STRING -        String  
 
//--------------------------------------------------------------------------------------- 
//     LCD
//    (lcd= 0  7)      LCD    . 
//--------------------------------------------------------------------------------------- 
	//---------------addr,cols,rows,lcd
	lcd.configDevice( 63,  20,  4,   0); 
	lcd.configDevice( 62,  16,  2,   1);  
	lcd.configDevice( 39,  16,  2,   2); 
	lcd.configDevice( 38,  16,  2,   3);

//--------------------------------------------------------------------------------------- 
//     LCD
//     (   )  .
//          (i2c)    .
//   begin()     lcd.DEVICE[lcd].init_ID,      
//--------------------------------------------------------------------------------------- 
	//+++++++++++++++++++++++  Lcd +++++++++++++++++++++++++++++++++++
if (RT_Hardware_Sheduler_getPermit()){
lcd.begin(0);
lcd.begin(1);
lcd.begin(2);
lcd.begin(3);
}	
//--------------------------------------------------------------------------------------- 
//     
//---------------------------------------------------------------------------------------  
if(lcd.DEVICE[LCD].init_ID) {lcd.DEVICE[LCD].init_ID=0;
   //-----------------------------col,row,lcd,len,point,alig 
	lcd.configChar (&id0_Blink,    0,  0,  0);          		id0_Blink='*';
    lcd.configInt16(&id0_Sonar,    1,  3,  0,  4, 'R');         id0_Sonar1.val=99;     
    lcd.configFloat(&id0_DHT_t,    4,  1,  0,  5,  2,    'R');  id0_DHT_t1.val=NAN;    
    lcd.configString(&id0_MSS_t,   0,  1,  0,   3,       'L');  id0_MSS_t1.val="t1=";
}
//--------------------------------------------------------------------------------------- 
//     
//     ,   .
// back= RT_Hardware_Sheduler_getBack();
//---------------------------------------------------------------------------------------
if (back!=0) {
   //-- 0          
              lcd.printChar (&id0_Blink1);
              lcd.printInt16(&id0_Sonar1);
              lcd.printInt16(&id0_Sonar2);
              lcd.printInt16(&id0_Sonar3);
              lcd.printInt16(&id0_Sonar4);
              
              lcd.printFloat(&id0_DHT_t1);
              lcd.printFloat(&id0_DHT_h1);   
              lcd.printFloat(&id0_DHT_t2);
              lcd.printFloat(&id0_DHT_h2);    

             lcd.printString(&id0_MSS_head); 
             lcd.printString(&id0_MSS_t1); 
             lcd.printString(&id0_MSS_h1); 
             lcd.printString(&id0_MSS_t2); 
             lcd.printString(&id0_MSS_h2);                                              
             }	
   ,    	
  (       )		 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*****************************************************************************************/
  
 