//=================================================================================================
//        Предопределение функций
//=================================================================================================
void printDevice(uint8_t num);
void initID_Next(uint8_t test);
void testArr_Next(uint8_t test);
void printArr(uint8_t num);
void changeArr(uint8_t num);
//=================================================================================================
//        Функция выводов параметров устройства
//=================================================================================================
void printDevice(uint8_t num){
RT_HW_Base.printTxt(String(F("set=")));             RT_HW_Base.printVal ('B',8,';',RT_HW_Next.hive.set); 
RT_HW_Base.printTxt(String(F(" qnt,num,state->"))); RT_HW_Base.print_v8 ('U',1,'~',4,RT_HW_Next.hive.qnt,RT_HW_Next.getParam(num,RT_HW_NEXT_PARAM_NUM), RT_HW_Next.getParam(num,RT_HW_NEXT_PARAM_STATE));   
RT_HW_Base.printTxt(String(F(" len=>B,W,L:")));     RT_HW_Base.print_v8 ('U',1,'~',3,RT_HW_Next.getLenArr(num,'B'),RT_HW_Next.getLenArr(num,'W'),RT_HW_Next.getLenArr(num,'L'));
RT_HW_Base.printTxt(String(F(" ptr=>D,B,W,L:")));   RT_HW_Base.print_v32('U',4,'~',6,RT_HW_Next.getPtrDev(num),    RT_HW_Next.getPtrArr(num,'B'),RT_HW_Next.getPtrArr(num,'W'),RT_HW_Next.getPtrArr(num,'L'));
RT_HW_Base.printCR(); }
//=================================================================================================
//        Функция инициализация ID устройств NEXT
//=================================================================================================
void initID_Next(uint8_t test=0){
if(test) {
  RT_HW_Base.printTxt(String(F("**** INIT=>set,qnt:"))); RT_HW_Base.printVal('H',3,',',RT_HW_Next.hive.set); RT_HW_Base.printVal('U',1,';',RT_HW_Next.hive.qnt); RT_HW_Base.printCR();
  RT_HW_Base.printTextStr(String(F("INIT ID(1-6) and printDevice")),80,'C','-','Y'); 
  RT_HW_Base.printBlank(80,'-','Y'); for(int i=0;i<8;i++){printDevice(i);}  RT_HW_Base.printBlank(80,'-','Y');
  printDevice(0);}
RT_HW_Next.setDeviceID(z1,1,115200,arrByte_z1,arrWord_z1,arrLong_z1, sizeof(arrByte_z1), sizeof(arrWord_z1), sizeof(arrLong_z1));   if(test) {printDevice(1);}
RT_HW_Next.setDeviceID(z2,1,115200,arrByte_z2,arrWord_z2,arrLong_z2, sizeof(arrByte_z2), sizeof(arrWord_z2), sizeof(arrLong_z2));   if(test) {printDevice(2);}
RT_HW_Next.setDeviceID(z3,1,115200,arrByte_z3,arrWord_z3,arrLong_z3, sizeof(arrByte_z3), sizeof(arrWord_z3), sizeof(arrLong_z3));   if(test) {printDevice(3);}
RT_HW_Next.setDeviceID(z4,1,115200,arrByte_z4,arrWord_z4,arrLong_z4, sizeof(arrByte_z4), sizeof(arrWord_z4), sizeof(arrLong_z4));   if(test) {printDevice(4);}
RT_HW_Next.setDeviceID(z5,1,115200,arrByte_z5,arrWord_z5,arrLong_z5, sizeof(arrByte_z5), sizeof(arrWord_z5), sizeof(arrLong_z5));   if(test) {printDevice(5);}
RT_HW_Next.setDeviceID(z6,1,115200,arrByte_z6,arrWord_z6,arrLong_z6, sizeof(arrByte_z6), sizeof(arrWord_z6), sizeof(arrLong_z6));   if(test) {printDevice(6);};
if(test) {RT_HW_Base.printBlank(80,'=','Y');}
}
//=================================================================================================
//        Функция тестирования изменения параметров массива
//=================================================================================================
void testArr_Next(){
RT_HW_Base.printTextStr(String(F("Значение массивов  до   изменений")),80,'C','*','Y'); printArr(6); 
changeArr(6);                   //--Изменения параметров 
RT_HW_Base.printTextStr(String(F("Значение массивов после изменения")),80,'C','*','Y'); printArr(6);};
//=================================================================================================
//        Функция вывода параметров массива
//=================================================================================================
void printArr(uint8_t num){
RT_HW_Base.printBlank(80,'-','Y'); for(int8_t i=0; i<num; i++){Serial.print(F("B->num,len=")); RT_HW_Base.printVal('U',1,',',i);      RT_HW_Base.printVal('U',1,' ',   RT_HW_Next.getLenArr(i,'B')); 
                                   for(int8_t j=0; j<RT_HW_Next.getLenArr(i,'B'); j++){        RT_HW_Base.printVal('I',4,' ', (int8_t)RT_HW_Next.getValArr(i,'B',j));} RT_HW_Base.printCR();} 
RT_HW_Base.printBlank(80,'-','Y'); for(int8_t i=0; i<num; i++){Serial.print(F("W->num,len=")); RT_HW_Base.printVal('U',1,',',i);      RT_HW_Base.printVal('U',1,' ',   RT_HW_Next.getLenArr(i,'W'));  
                                   for(int8_t j=0; j<RT_HW_Next.getLenArr(i,'W'); j++){        RT_HW_Base.printVal('I',6,' ',(int16_t)RT_HW_Next.getValArr(i,'W',j));} RT_HW_Base.printCR();}
RT_HW_Base.printBlank(80,'-','Y'); for(int8_t i=0; i<num; i++){Serial.print(F("L->num,len=")); RT_HW_Base.printVal('U',1,',',i);      RT_HW_Base.printVal('U',1,' ',   RT_HW_Next.getLenArr(i,'L')); 
                                   for(int8_t j=0; j<RT_HW_Next.getLenArr(i,'L'); j++){        RT_HW_Base.printVal('I',9,' ',(int32_t)RT_HW_Next.getValArr(i,'L',j));} RT_HW_Base.printCR();} 
RT_HW_Base.printBlank(80,'-','Y');  }
//=================================================================================================
//        Функция изменения параметров массива
//=================================================================================================
void changeArr(uint8_t num){
for(int8_t i=0; i<num; i++){for(int8_t j=0; j<RT_HW_Next.getLenArr(i,'B'); j++){uint8_t  v=RT_HW_Next.getValArr(i,'B',j)+(j+1)*10;   RT_HW_Next.setValArr(i,'B',j,v);}} 
for(int8_t i=0; i<num; i++){for(int8_t j=0; j<RT_HW_Next.getLenArr(i,'W'); j++){uint16_t v=RT_HW_Next.getValArr(i,'W',j)+(j+1)*100;  RT_HW_Next.setValArr(i,'W',j,v);}} 
for(int8_t i=0; i<num; i++){for(int8_t j=0; j<RT_HW_Next.getLenArr(i,'L'); j++){uint32_t v=RT_HW_Next.getValArr(i,'L',j)+(j+1)*1000; RT_HW_Next.setValArr(i,'L',j,v);}}}
//=================================================================================================
