
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Возвращает 1, если устройство наличия и доступности(permit=1) после настройки парамеров; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_NEXT:: deviceCheckNum(uint8_t num){
	if((num<=RT_HW_NEXT_MAX_DEVICE) && (ptr[num]->permit)) {return 1;} else {return 0;}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Получение адреса указателя на устройство (для отладки)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t RT_HW_NEXT:: getPtrDev(uint8_t num){if(deviceCheckNum(num)) {return (uint32_t)ptr[num];} 
															   else  {return (uint32_t)ptr[0];}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Получение адреса указателя на массив
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t RT_HW_NEXT:: getPtrArr(uint8_t num, char mode){if(deviceCheckNum(num)){ 
if(mode=='B'){return (uint32_t)ptr[num]->ptrArrByte;}
if(mode=='W'){return (uint32_t)ptr[num]->ptrArrWord;}
if(mode=='L'){return (uint32_t)ptr[num]->ptrArrLong;}}
return (uint32_t)ptr[0]->ptrArrLong;}	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     Получение длины массива
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t  RT_HW_NEXT:: getLenArr(uint8_t num, char mode){if(deviceCheckNum(num)){ 
if(mode=='B'){return ptr[num]->lenArrByte;}
if(mode=='W'){return ptr[num]->lenArrWord;}
if(mode=='L'){return ptr[num]->lenArrLong;}} 
return 0;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     Получение параметра по номеру устройтства (num,state,uart)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//uint8_t  RT_HW_NEXT:: getParam(uint8_t num, uint8_t mode){if(!checkDev(num)) {num=0;} 
//if(mode==RT_HW_NEXT_PARAM_BLINK)  	{return ptr[num]->blink;}
//if(mode==RT_HW_NEXT_PARAM_STATE)	{return ptr[num]->state;}
//if(mode==RT_HW_NEXT_PARAM_UART)		{return ptr[num]->uart;}
//if(mode==RT_HW_NEXT_PARAM_NUM)  	{return ptr[num]->num;}
//return 0;}
//void  RT_HW_NEXT:: setParam(uint8_t num, uint8_t mode){if(!checkDev(num)) {num=0;} 
//if(mode==RT_HW_NEXT_PARAM_BLINK)  	{return ptr[num]->blink;}
//if(mode==RT_HW_NEXT_PARAM_NUM)  	{return ptr[num]->num;}
//if(mode==RT_HW_NEXT_PARAM_STATE)	{return ptr[num]->state;}
//if(mode==RT_HW_NEXT_PARAM_UART)		{return ptr[num]->uart;}
//return 0;}


//bool	RT_HW_NEXT:: getBlink(uint8_t num)	   {return ptr[num]->blink;};
//void	RT_HW_NEXT:: setStateReady(uint8_t num){if(!checkDev(num)) {num=0;} ptr[num]->state= RT_HW_NEXT_STATE_READY;}
//void    RT_HW_NEXT:: setStateBusy (uint8_t num){if(!checkDev(num)) {num=0;} ptr[num]->state= RT_HW_NEXT_STATE_BUSY;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     Получение параметра по номеру устройтства (num,state,uart)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//uint32_t RT_HW_NEXT:: getSpeedUART(uint8_t num){if(!checkDev(num)) {num=0;} return ptr[num]->speed;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//    Получение данных из массива
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t  RT_HW_NEXT:: getValArr (uint8_t num, char mode, uint8_t index){if(deviceCheckNum(num)){
if(mode=='B'){if(index>=getLenArr(num,'B')) {return 0;} else {uint8_t  *arr=ptr[num]->ptrArrByte; return arr[index];}}
if(mode=='W'){if(index>=getLenArr(num,'W')) {return 0;} else {uint16_t *arr=ptr[num]->ptrArrWord; return arr[index];}}
if(mode=='L'){if(index>=getLenArr(num,'L')) {return 0;} else {uint32_t *arr=ptr[num]->ptrArrLong; return arr[index];}}}
return 0;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//    Установка данных в массивах
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_NEXT:: setValArr (uint8_t num, char mode, uint8_t index, uint32_t val){if(deviceCheckNum(num)){
if(mode=='B'){if(index>=getLenArr(num,'B')) {return;} else {uint8_t  *arr=ptr[num]->ptrArrByte; arr[index]= (uint8_t)val;}}
if(mode=='W'){if(index>=getLenArr(num,'W')) {return;} else {uint16_t *arr=ptr[num]->ptrArrWord; arr[index]=(uint16_t)val;}}
if(mode=='L'){if(index>=getLenArr(num,'L')) {return;} else {uint32_t *arr=ptr[num]->ptrArrLong; arr[index]=(uint32_t)val;}}}
}			  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



